// --- Usage examples for the prototype implementation of
// --- XML Specification of Time, Positions and Parts of a Waveform 
// Jens Gulden 08/2005, jgulden@cs.tu-berlin.de

// --- start server ---
Server.local.boot;

// -----------------------------------------------------------------

// TEST 1: short form 
//         (SFSliceInstrument plays first Cuelist by default.)

SFSliceInstrument.new("examples/slice.xml").verbose_(true).play;

// or even shorter, without console output:

SFSliceInstrument.new("examples/slice.xml").play;

// -----------------------------------------------------------------

// TEST 2: equal to test 1, but in more detailed steps

i = SFSliceInstrument.new;
i.loadXML("examples/slice.xml");
c = i.getCuelist("song");
c.play(1.0, true);

// -----------------------------------------------------------------

// TEST 3: using the class library from SuperCollider language, 
//         without XML

p = "examples/audio/NosNodOrr.wav";
f = SF3(p, 1000);

s = SFSlice.newMaster(f)
           .slice("start", "20.55839s")   // (each sliceX() returns
           .sliceTo("leer", "27.69878s")  // the parent-slice again)
           .sliceTo("zwischen", "34.83637s")
           .sliceRange("wummer", "33.06s", "34.82s")
           .sliceRange("basis", "34.9s", "49.16338s")
           .sliceRange("funny", "49.19s", "56.33s")
           .sliceRange("melody1", "56.35s", "63.46s")
           .sliceTo("melody2", "70.8s")
           .sliceTo("melody3", "77.8371s")
           .sliceTo("end", 1.0);

c = SFCuelist.new(s)
.cue("start")
.cue("zwischen")
.cue("wummer", 4)
.cue("basis")
.cue("funny")
.cue("melody1", 2)
.cue("melody2")
.cue("basis")
.cue("melody1", 2)
.cue("melody3")
.cue("wummer", 8)
.cue("funny")
.cue("melody1")
.cue("melody2")
.cue("melody3")
.cue("end")
.cue("melody2")
.cue("melody1")
.cue("melody2")
.cue("melody3")
.cue("melody1", 2)
.cue("melody2")
.cue("end")
.play;

